package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import android.app.Activity;
import android.content.Intent;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.res.Configuration;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Button;
import android.util.Log;
import android.content.SharedPreferences;
import android.os.Environment;
import java.io.FilenameFilter;
import java.io.File;
import java.util.ArrayList;
import android.widget.LinearLayout;
import android.view.ViewGroup;
import java.util.Comparator;
import java.util.Collections;
import org.json.JSONObject;
import org.json.JSONArray;
import org.json.JSONException;
import android.util.TypedValue;
import android.graphics.Color;
import android.view.Gravity;
import java.util.zip.ZipFile;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.io.InputStream;
import java.io.ByteArrayOutputStream;
import java.io.BufferedInputStream;
import android.os.Handler;

public class Library extends Activity {
	private static final String DBG="FlashCards";
	private Globals globals;
	private Handler onehandler;
	private Runnable delayscan;
	class onefile {
		String name;
		String filename;
		int internalindex;
		onefile(String a, String b, int c) {
			name=a;filename=b;internalindex=c;
		}
	}
	private ArrayList<onefile> allfiles=new ArrayList<onefile>();
	private AlertDialog alert=null;

	private String readzipfile(File f,String fn) {
		ZipFile ZF;
		ZipEntry ZE;
		InputStream IS;
		try { ZF=new ZipFile(f); }
			catch(java.util.zip.ZipException e) { return null; }
			catch(java.io.IOException e) { return null; }
		ZE=ZF.getEntry(fn);
		if (ZE==null) return null;
		try { IS=ZF.getInputStream(ZE); } catch(java.io.IOException e) { return null; }
		return datautils.slurpstream(IS);
	}
	private void searchzip(ArrayList<onefile> dest, File f) {
		String name;
		name=readzipfile(f,"title.txt");
		if (name==null) return;
		name=name.trim();
		dest.add(new onefile(name,f.getPath(),-1));
	}
	private void searchdir(ArrayList<onefile> dest, File dir) {
		File[] entries;
		entries=dir.listFiles();
		if (entries==null) return;
		for (File e: entries) {
			if (e.isDirectory()) searchdir(dest,e);
			else if (e.getName().endsWith("flashcards.zip")) {
				searchzip(dest,e);
			}
		}
	}
	private void addinternals(ArrayList<onefile> dest) {
		if (!globals.showbuiltins) return;
		dest.add(new onefile("* Atomic Symbols",null,1)); 
		dest.add(new onefile("* Flags of Europe",null,2)); 
		dest.add(new onefile("* US Presidential Succession",null,3)); 
		dest.add(new onefile("* World Capitals",null,4)); 
	}
	private void dontwait() {
		if (alert!=null) {
			if (alert.isShowing()) alert.dismiss();
			alert=null;
		}
	}
	private void pleasewait(String str) {
		dontwait();
		if (str==null) str=getString(R.string.scanning);
		alert=new AlertDialog.Builder(Library.this).setTitle(R.string.pleasewait).setMessage(str).create();
		alert.show();
	}
	private void error(String str) {
		dontwait();
		alert=new AlertDialog.Builder(Library.this)
				.setTitle(R.string.error)
				.setNegativeButton(R.string.cancel,
						new DialogInterface.OnClickListener() { public void onClick(DialogInterface dialog, int ign) { } })
				.setMessage(str).create();
		alert.show();
	}
	private class filesort implements Comparator<onefile> {
		public int compare(onefile a, onefile b) {
			return a.name.compareTo(b.name);
		}
	}
	private void savefilestoprefs(ArrayList<onefile> src) {
		try {
			JSONObject json=new JSONObject();
			JSONArray a=new JSONArray();
			for (int i=0,n=src.size();i<n;i++) {
				onefile one=src.get(i);
				JSONObject o=new JSONObject();
				o.put("fn",one.filename);
				o.put("title",one.name);
				a.put(o);
			}
			json.put("files",a);
			globals.librarylist=json.toString();
			globals.savepreferences();
		} catch (org.json.JSONException e) {
			Log.e(DBG,"JSON Exception saving list");
		}
	}
	private void scandir() {
		allfiles=new ArrayList<onefile>();
		redraw();
		pleasewait(null);
		onehandler.postDelayed(delayscan,100);
	}
	private void scandirB() {
		String status=Environment.getExternalStorageState();
		if (status.equals("mounted")) {
			File fs=Environment.getExternalStorageDirectory();
			searchdir(allfiles,fs);
			System.gc();
		}
		savefilestoprefs(allfiles);
		addinternals(allfiles);
		Collections.sort(allfiles,new filesort());
		globals.needscan=false;
		redraw();
	}
	private void loadfilesfromprefs(ArrayList<onefile> dest) throws org.json.JSONException {
		String data=globals.librarylist;
		JSONObject json=new JSONObject(data);
		JSONArray a=json.getJSONArray("files");
		for (int i=0,n=a.length();i<n;i++) {
			JSONObject o;
			String fn,title;
			o=a.getJSONObject(i);
			title=o.optString("title");
			fn=o.getString("fn");
			dest.add(new onefile(title,fn,-1));
		}
	}
	private void downloadviacode() {
		Intent intent=new Intent();
		intent.setClass(this,Download.class);
		startActivity(intent);
		finish();
	}
	private void showaddhelp() {
		alert=new AlertDialog.Builder(Library.this)
						.setTitle(R.string.addingstrings)
						.setMessage(R.string.addingstringsinst)
						.setNeutralButton(R.string.ok,new DialogInterface.OnClickListener() { public void onClick(DialogInterface dialog, int ign) { } })
						.create();
		alert.show();
	}
	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}
	@Override
	public void onCreate(Bundle savedInstanceState) {
		globals=(Globals)((Globalcontainer)getApplicationContext()).globals;
		globals.init(this);
		super.onCreate(savedInstanceState);
		try { loadfilesfromprefs(allfiles); } catch (org.json.JSONException e) {}
		addinternals(allfiles);
		Collections.sort(allfiles,new filesort());
		onehandler=new Handler();
		delayscan = new Runnable() { public void run() { scandirB(); } };
	}
	@Override
	public void onResume() {
		super.onResume();
		setContentView(R.layout.library);
		globals.cleanquiz();
		((Button)findViewById(R.id.button_scan)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { scandir(); }
			});
		((Button)findViewById(R.id.button_download)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { downloadviacode(); }
			});
		((Button)findViewById(R.id.button_addhelp)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { showaddhelp(); }
			});
		if (globals.needscan) scandir();
		else redraw();
	}
	private void deletefile(int index) {
		onefile f=allfiles.get(index);
		File file=new File(f.filename);
		file.delete();
		scandir();
	}
	private void longclickonfile(final int index) {
		onefile f=allfiles.get(index);
		String str;
		if (f.filename==null) {
			error(getString(R.string.cantdelete));
			return;
		}
		str=f.name+"\n\n"+f.filename;
		alert=new AlertDialog.Builder(Library.this)
					.setTitle(R.string.dodelete)
					.setMessage(str)
					.setPositiveButton(R.string.ok,
						new DialogInterface.OnClickListener() { public void onClick(DialogInterface dialog, int ign) { deletefile(index); } })
					.setNegativeButton(R.string.cancel,
						new DialogInterface.OnClickListener() { public void onClick(DialogInterface dialog, int ign) { } })
					.create();
		alert.show();
	}
	private void clickonfile(int index) {
		onefile f=allfiles.get(index);
		String err;
		pleasewait(f.filename);
		err=globals.loadquiz(f.internalindex,f.filename);
		if (err!=null) error(err);
		else if (globals.quiz.missingfilenames.length>0) {
			error("There are missing files inside the archive.\nSee <www.survey7.com/flashcards/> for instructions on adding images.\n\n"+datautils.stringjoin(globals.quiz.missingfilenames,"\n"));
		} else {
			dontwait();
			globals.startquiz(null,true,false);
			Intent intent=new Intent();
			intent.setClass(this,Pause.class);
			startActivity(intent);
		}
	}
	private void addfile(LinearLayout holder, onefile file, final int index, int last) {
		TextView tv;
		tv = new TextView(this);
		tv.setText(file.name);
		tv.setTextSize(TypedValue.COMPLEX_UNIT_SP,(float)32);
		tv.setLayoutParams(new LinearLayout.LayoutParams(
			ViewGroup.LayoutParams.FILL_PARENT,
			ViewGroup.LayoutParams.WRAP_CONTENT));
		tv.setGravity(Gravity.CENTER_HORIZONTAL);
		holder.addView(tv);
		tv.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) { clickonfile(index); }
		});
		tv.setOnLongClickListener(new View.OnLongClickListener() {
			@Override
			public boolean onLongClick(View v) { longclickonfile(index); return true; }
		});
		if (index!=last) {
			tv=new TextView(this);
			tv.setTextSize(TypedValue.COMPLEX_UNIT_SP,(float)0.1);
			tv.setText(" ");
			tv.setBackgroundColor(Color.DKGRAY);
			LinearLayout.LayoutParams lp;
			lp=new LinearLayout.LayoutParams(ViewGroup.LayoutParams.FILL_PARENT,
				ViewGroup.LayoutParams.WRAP_CONTENT);
			lp.setMargins(50,0,50,0);
			tv.setLayoutParams(lp);
			holder.addView(tv);
		}
	}
	private void redraw() {
		LinearLayout fileholder;
		fileholder=(LinearLayout)findViewById(R.id.fileholder);
		fileholder.removeAllViews();
		for (int i=0,n=allfiles.size(),nm1=n-1;i<n;i++) addfile(fileholder,allfiles.get(i),i,nm1);
		dontwait();
		System.gc();
	}
}
