package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.res.Configuration;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.text.Html;
import android.view.Window;
import android.view.View;
import android.widget.TextView;
import android.widget.Button;
import android.util.Log;
import android.text.method.LinkMovementMethod;

public class Main extends Activity {
	private static final String DBG="FlashCards";

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}
	private Globals globals;
	private void savegpl() {
		globals.isgplapproved=true;
		globals.savepreferences();
	}
	private void showgpl() {
		AlertDialog ad=new AlertDialog.Builder(Main.this).setTitle(R.string.gpltitle).setMessage(Html.fromHtml(getString(R.string.gplmessage))).setPositiveButton(R.string.ok,new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int ign) {
					savegpl();
				}
			}).create();
		ad.show();
		((TextView)ad.findViewById(android.R.id.message)).setMovementMethod(LinkMovementMethod.getInstance());
	}
	@Override
	public void onCreate(Bundle savedInstanceState) {
		globals=(Globals)((Globalcontainer)getApplicationContext()).globals;
		globals.init(this);
		super.onCreate(savedInstanceState);
/* START */
// This block is copied from stackoverflow.com to fix launcher oddity. Copyright unknown.
// This blocks a second start
		if (!isTaskRoot()) {
			final Intent intent = getIntent();
			final String intentAction = intent.getAction();
			if (intent.hasCategory(Intent.CATEGORY_LAUNCHER) &&
							intentAction != null && intentAction.equals(Intent.ACTION_MAIN)) {
					finish();
					return;
			}
		}
/* END */
/*
// This is original but doesn't work. I don't know why.
// This is intended to replace an odd start with an expected start
		Intent intent=getIntent();
		int flags;
		flags=intent.getFlags();
		if (0==(flags&Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED)) {
// I don't know why but the installer will run differently, confusing everything
			Intent bugfix=new Intent();
			bugfix.setClass(this,Main.class);
			bugfix.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK|Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED);
			bugfix.addCategory(Intent.CATEGORY_LAUNCHER);
			startActivity(bugfix);
			finish();
		}
*/
	}
	@Override
	public void onResume() {
		super.onResume();
		globals.cleanquiz();
		setContentView(R.layout.main);
		Button b=(Button)findViewById(R.id.button_demo);
		if (!globals.lastquiz_title.equals("")) b.setText(globals.lastquiz_title);
		b.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) {
					globals.loadquiz(globals.lastquiz_int,globals.lastquiz_filename);
					globals.startquiz(null,true,false);
					if (null!=globals.quiz) startintent(Pause.class);
					else {
						((Button)findViewById(R.id.button_demo)).setText(R.string.errorloading);
					}
				}
			});
		((Button)findViewById(R.id.button_about)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { showgpl(); }
			});
		((Button)findViewById(R.id.button_library)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { startintent(Library.class); }
			});
		((Button)findViewById(R.id.button_httpcode)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { startintent(Download.class); }
			});
		((Button)findViewById(R.id.button_options)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { startintent(Options.class); }
			});
		if (!globals.isgplapproved) showgpl();
	}
	private void startintent(Class cl) {
		Intent intent=new Intent();
		intent.setClass(this,cl);
		startActivity(intent);
	}
}
