package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import android.content.res.Configuration;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.Html;
import android.view.Window;
import android.view.View;
import android.widget.TextView;
import android.widget.Button;
import android.util.Log;
import android.widget.ProgressBar;
import android.widget.LinearLayout;
import android.view.ViewGroup;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.res.Configuration;
import android.view.Gravity;

public class Pause extends Activity {
	private static final String DBG="FlashCards";
	private Globals globals;
	private int restartbuttonindex=0;
	private int restartpageindex=0;

	private void continue_click() {
		Intent intent=new Intent();
		intent.setClass(this,FlashCards.class);
		globals.quiz.stamptime(true);
		startActivity(intent);
	}
	private void resettimer_click() {
		globals.countdown=globals.defcountdown;
		globals.savepreferences();
		continue_click();
	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}
	private void setup() {
		setContentView(R.layout.pause);
		((Button)findViewById(R.id.button_continue)).setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) { continue_click(); }
		});
		((Button)findViewById(R.id.button_restart)).setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				globals.startquiz(null,false,false);
				continue_click();
			}
		});
		((Button)findViewById(R.id.button_pauseoptions)).setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				Intent intent=new Intent();
				intent.setClass(Pause.this,Options.class);
				startActivity(intent);
			}
		});
		((Button)findViewById(R.id.button_repeatmissed)).setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				if (0!=globals.quiz.missedcards.size()) {
					globals.startquiz(null,false,true);
					continue_click();
				}
			}
		});
		((Button)findViewById(R.id.button_resettimer)).setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) { resettimer_click(); }
		});
	}
	@Override
	public void onCreate(Bundle savedInstanceState) {
		globals=(Globals)((Globalcontainer)getApplicationContext()).globals;
		globals.init(this);
		super.onCreate(savedInstanceState);
	}
	@Override
	public void onResume() {
		super.onResume();
		if (globals.quiz.autostart) {
			continue_click();
			globals.quiz.autostart=false;
		} else {
			setup();
			redraw();
		}
	}
	private void addwrongtitle(LinearLayout dest) {
		TextView tv;
		tv=new TextView(this);
		tv.setText(R.string.wrongtitle);
		tv.setLayoutParams(new LinearLayout.LayoutParams(
			ViewGroup.LayoutParams.FILL_PARENT,
			ViewGroup.LayoutParams.WRAP_CONTENT));
		tv.setGravity(Gravity.CENTER_HORIZONTAL);
		dest.addView(tv);
/*
			tv.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { clickbutton(v,finalindex); }
			});
*/
	}
	private void clickwrong(String title, String body) {
		AlertDialog alert=null;
		alert=new AlertDialog.Builder(Pause.this).setTitle(title).setMessage(body).setNeutralButton(R.string.ok,new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int ign) {
				}
			}).create();
		alert.show();
	}
	private void addwrong(LinearLayout dest, card card) {
		TextView tv;
		String text,left;
		text=card.question;
		left=card.leftn.string;
		if (left.equals("") && (card.leftn.bitmap!=null)) left="[Image]";
		if (text==null) text=card.dim+", "+left+": "+card.right();
		else text+=": "+card.right();
		tv=new TextView(this);
		tv.setText(text);
		tv.setLayoutParams(new LinearLayout.LayoutParams(
			ViewGroup.LayoutParams.FILL_PARENT,
			ViewGroup.LayoutParams.WRAP_CONTENT));
		dest.addView(tv);
		final String fleft=left;
		final String facts=globals.notionjoin(card.facts,"\n");
		tv.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) { clickwrong(fleft,facts); }
		});
	}
	private String score(quiz quiz, int seconds) {
		int n,d;
		n=quiz.rightscore;
		d=n+quiz.wrongscore;
		if (d==0) return "";
		return "\nScore: "+(100*n/d)+"% in "+seconds+" second"+((seconds==1)?"":"s");
	}
	private void redraw() {
		String title;
		int prog;
		LinearLayout wrongs;
		quiz quiz=globals.quiz;
		int duration;
		duration=globals.quiz.stamptime(false);
		title=quiz.title+" "+(1+quiz.cursor)+" of "+quiz.sequence.size()+score(quiz,duration);
		((TextView)findViewById(R.id.title)).setText(title);
		prog=(100+100*quiz.cursor)/quiz.sequence.size();
		((ProgressBar)findViewById(R.id.progress)).setProgress(prog);
		wrongs=(LinearLayout)findViewById(R.id.wrongcards);
		wrongs.removeAllViews();
		int n=quiz.missedcards.size();
		if (n>0) {
			((Button)findViewById(R.id.button_repeatmissed)).setVisibility(View.VISIBLE);
			addwrongtitle(wrongs);
			for (int i=0;i<n;i++) addwrong(wrongs,quiz.missedcards.get(i));
		}
		if (globals.countdown<=0)
			((Button)findViewById(R.id.button_resettimer)).setVisibility(View.VISIBLE);
	}
}
