package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.util.Collections;
import java.util.Arrays;
import android.os.Handler;
import android.content.res.Configuration;
import android.app.Activity;
import android.os.Bundle;
import android.text.Html;
import android.view.GestureDetector;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.MotionEvent;
import android.view.Window;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Button;
import android.view.ViewGroup;
import android.util.Log;
import java.lang.StringBuilder;
import android.text.SpannableString;
import android.text.style.UnderlineSpan;
import android.graphics.Color;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.util.TypedValue;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.Bitmap;


public class buttonside implements cardside {
	private static final String DBG="FlashCards";
	private Globals globals;
	float dpratio;
	FlashCards FC;
	notion[] answerns;
	boolean[] rightanswers;
	card curcard;
	public void setactivity(FlashCards act) {
		FC=act;
		globals=(Globals)((Globalcontainer)FC.getApplicationContext()).globals;
		dpratio=globals.dpratio;
	}
	public void unsetup() {}
	public void setup() {
		FC.setContentView(R.layout.buttons);
	}
	private void dontcare() {
		FC.nextcard();
	}
	private void clickbutton(View v,int answerindex) {
		notion ptr=answerns[answerindex];
		card card=curcard;
		for (int i=0,n=card.rightns.length;i<n;i++) {
			if (ptr!=card.rightns[i]) continue;
			if (n==1) { FC.nextcard(); return; }
			((Button)v).setTextColor(Color.GREEN);
			rightanswers[i]=true;
			for (int j=0;j<n;j++) if (!rightanswers[j]) return;
			FC.nextcard();
			return;
		}
		((Button)v).setTextColor(Color.RED);
		Animation anim=AnimationUtils.loadAnimation(FC,R.anim.wrong);
		v.startAnimation(anim);
		globals.vibrate(400);
		FC.wronganswer();
	}
	private void addbutton(LinearLayout buttholder, notion not, int index) {
		Button butt;
		final int finalindex=index;
		FC.addwikilink(not.string);
		butt=new Button(FC);
		if (not.bitmap!=null) {
			Drawable d;
			Bitmap bmp;
			bmp=globals.makebitmap(not.bitmap);
			int w,h;
			d=new BitmapDrawable(bmp);
			butt.setBackgroundDrawable(d);
			w=bmp.getWidth();
			h=bmp.getHeight();
			if ((w>0)&&(h>0)) {
				LinearLayout.LayoutParams lp;
				lp=new LinearLayout.LayoutParams(
					(int)(200*dpratio),
					(int)((200*h*dpratio)/w));
				lp.setMargins(0,0,0,20);
				butt.setLayoutParams(lp);
			}
		} else {
			butt.setTextSize(TypedValue.COMPLEX_UNIT_SP,(float)28);
			butt.setLayoutParams(new LinearLayout.LayoutParams(
				ViewGroup.LayoutParams.FILL_PARENT,
				ViewGroup.LayoutParams.WRAP_CONTENT));
		}
		butt.setText(not.string);
		buttholder.addView(butt);
		butt.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) { clickbutton(v,finalindex); }
		});
	}
	public void dontknow() {
		LinearLayout buttholder;
		int i,n;
		card card=curcard;

		buttholder=(LinearLayout)FC.findViewById(R.id.buttonholder);
		buttholder.removeAllViews();
		answerns=new notion[card.rightns.length];
		System.arraycopy(card.rightns,0,answerns,0,card.rightns.length);
//		Arrays.sort(answers);
		n=answerns.length;
		for (i=0;i<n;i++) addbutton(buttholder,answerns[i],i);
		FC.wronganswer();
	}
	private boolean rightsinwrongs(notion[] rights, notion[] wrongs) {
		int i,j,n,m;
		n=rights.length;
		m=wrongs.length;
		for (i=0;i<n;i++) {
			notion needle=rights[i];
			j=0;
			while (true) {
				if (needle==wrongs[j]) break;
				j++;
				if (j==m) return false;
			}
		}
		return true;
	}
	public void drawcard(card card, boolean ignore) {
		LinearLayout layout;
		LinearLayout buttholder;
		String banner;
		int i,n;

		curcard=card;

		FC.addwikilink(card.leftn.string);
		FC.addwikilink(card.question);

		rightanswers=new boolean[card.rightns.length];
		if (rightsinwrongs(card.rightns,card.wrongns)) {
			answerns=card.wrongns;
		} else {
// afaik, not used
			answerns=new notion[card.wrongns.length+card.rightns.length];
			System.arraycopy(card.wrongns,0,answerns,0,card.wrongns.length);
			System.arraycopy(card.rightns,0,answerns,card.wrongns.length,card.rightns.length);
//			Arrays.sort(answers); // TODO
		}
		banner=card.question;
		if (null==banner) {
			banner=card.dim;
			if (!banner.equals("")) banner+=" ";
			banner+=card.leftn.string;
		}

/*
		if (card.leftn.bitmap!=null) {
			((TextView)FC.findViewById(R.id.banner)).setBackgroundDrawable(new BitmapDrawable(card.leftn.bitmap));
		} else ((TextView)FC.findViewById(R.id.banner)).setBackgroundDrawable(null);
*/

		layout=(LinearLayout)FC.findViewById(R.id.buttonlayout);
		buttholder=(LinearLayout)FC.findViewById(R.id.buttonholder);
		globals.setnotion3(FC,R.id.banner,R.id.banner_iv,banner,card.leftn.bitmap,null);
		layout.setBackgroundColor(globals.bgcolor);
		n=answerns.length;
		for (i=0;i<n;i++) addbutton(buttholder,answerns[i],i);
		FC.setContentView(layout);
		((Button)FC.findViewById(R.id.dontknow)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { dontknow(); }
			});
		((Button)FC.findViewById(R.id.dontcare)).setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View v) { dontcare(); }
			});
	}
}
