package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.io.InputStream;
import java.io.FileInputStream;
import java.io.ByteArrayOutputStream;
import java.io.BufferedInputStream;

public class datautils {
	public static String stringjoin(String[] arr, String join) {
		if (arr.length==0) return "";
		StringBuilder sb=new StringBuilder();
		int i,n;
		n=arr.length;
		sb.append(arr[0]);
		for (i=1;i<n;i++) { sb.append(join); sb.append(arr[i]); }
		return sb.toString();
	}
	public static String slurpstream(InputStream is) {
		byte[] a=slurpstream2(is);
		if (a==null) return null;
		return new String(a);
	}
	public static byte[] slurpstream2(InputStream is) {
		byte[] bytes=new byte[4096];
		ByteArrayOutputStream os=new ByteArrayOutputStream();
		try { 
			while (true) {
				int k;
				k=is.read(bytes,0,4096);
				if (k<0) break;
				os.write(bytes,0,k);
			}
		} catch(java.io.IOException e) { return null; }
		return os.toByteArray();
	}
	public static InputStream openfile(String fn) {
		InputStream ret=null;
		try { ret=new FileInputStream(fn); }
		catch(java.io.FileNotFoundException e) {}
		return ret;
	}
}
