package com.survey7.flashcards;

/*
Copyright 2012 Sanjay Rao, Seattle WA USA

This file is part of Flash Cards GPL.

Flash Cards GPL is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

Flash Cards GPL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Flash Cards GPL.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.util.ArrayList;
import java.util.Collections;
import java.util.Arrays;
import android.util.Log;
import java.util.Random;

public class quiz {
	public boolean autostart;
	private static final String DBG="FlashCards";
	public int rightscore,wrongscore;
	private long storedtime;
	private long lasttime;
	private boolean clockrunning;
	private Random rand=new Random();
	public String title;
	public card[] cards;
	public String[] missingfilenames;
	public ArrayList<card> sequence;
	public ArrayList<card> missedcards;
	public int cursor;
	public int lastback;
	public boolean correct;
	public card curcard;
	public int random(int ceiling) {
		return rand.nextInt(ceiling);
	}
	public void setcorrect(boolean isco) {
		correct=isco;
	}
	public int stamptime(boolean starting) {
		long now=System.nanoTime();
		if (starting) {
			clockrunning=true;
			lasttime=now;
		} else {
			if (clockrunning) storedtime+=now-lasttime;
			clockrunning=false;
		}
		return (int)(storedtime/(long)(1000*1000*1000));
	}
	private void resetvars() {
		wrongscore=rightscore=0;
		clockrunning=false;
		storedtime=0;
		cursor=0;
		lastback=-1;
		correct=true;
		for (int i=0,n=cards.length;i<n;i++) cards[i].reset();
		curcard=sequence.get(cursor);
	}
	public void randomize() {
		Collections.shuffle(sequence);
		resetvars();
	}
	public void reverse() {
		Collections.reverse(sequence);
		resetvars();
	}
	public void forward() {
		resetvars();
	}
	public void reset(boolean qzmiss) {
		if (qzmiss&&missedcards.size()!=0) {
			sequence=missedcards;
			missedcards=new ArrayList<card>();
		} else {
			sequence=new ArrayList<card>(Arrays.asList(cards));
			missedcards=new ArrayList<card>();
		}
	}
	public void quizinterleave(boolean odds) {
		int i,n;
		sequence=new ArrayList<card>();
		missedcards=new ArrayList<card>();
		n=cards.length;
		if (odds) i=0; else i=1;
		for (;i<n;i+=2) sequence.add(cards[i]);
	}
	public card getcurrent() {
		return sequence.get(cursor);
	}
	public boolean islastcard() {
		if (cursor+1>=sequence.size()) return true;
		return false;
	}
	private void resequence(card card, boolean repeat) {
		int index=cursor;
		if (card.repeatstep<0) {
			if (card.corrects==1) return;
			missedcards.add(card);
			if (!repeat) return;
			card.repeatstep=8+random(4);
		} else {
			if (!repeat) return;
			if (card.corrects==3) return;
			else if (card.corrects==0) card.repeatstep-=random(3);
			else card.repeatstep+=2+random(3);
		}
		if (card.repeatstep<2) card.repeatstep=2;
		index+=card.repeatstep;
		if (index>=sequence.size()) sequence.add(card);
		else sequence.add(index,card);
	}
	public void repeatcard() {
		card card=sequence.get(cursor);
		rightscore--;
		wrongscore++;
		card.corrects=0;
		resequence(card,true);
	}
	public void nextcard(boolean repeat) {
		if (lastback+1==cursor) {
			lastback=cursor;
			if (!correct) {
				wrongscore++;
				curcard.corrects=0;
				resequence(curcard,repeat);
				correct=true;
			} else {
				rightscore++;
				curcard.corrects+=1;
				resequence(curcard,repeat);
			}
		}
		cursor++;
		curcard=sequence.get(cursor);
	}
	public void prevcard() {
		if (cursor>0) cursor--;
	}
}
